' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "GLFW.INC"
#INCLUDE ONCE "GDIPUTILS.INC"

' =======================================================================================
' Main
' =======================================================================================
FUNCTION PBMAIN () AS LONG

   LOCAL hr, nWidth, nHeight, running, frames, x, y AS LONG
   LOCAL t, t0, fps AS DOUBLE
   LOCAL szTitlestr AS ASCIIZ * 200
   LOCAL xrot, yrot AS SINGLE
   LOCAL strTextureData AS STRING
   LOCAL TextureWidth AS LONG
   LOCAL TextureHeight AS LONG
   LOCAL glHandle AS DWORD
   LOCAL box, top AS DWORD
   LOCAL xloop, yloop AS LONG

   ' Initialize GLFW
   glfwInit

   ' Open OpenGL window
   IF ISFALSE glfwOpenWindow(640, 480, 0, 0, 0, 0, 0, 0, %GLFW_WINDOW) THEN
      glfwTerminate
      EXIT FUNCTION
   END IF

   ' Load bitmap texture from disk
   hr = GdiPlusLoadTexture("cube.bmp", TextureWidth, TextureHeight, strTextureData, %TRUE)

   ' Assign an OpenGL handle to this texture
   glGenTextures 1, glHandle

   ' Create the texture
   glBindTexture %GL_TEXTURE_2D, glHandle
   glTexParameteri %GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR
   glTexParameteri %GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR
   glTexImage2D %GL_TEXTURE_2D, 0, 3, TextureWidth, TextureHeight, 0, _
                %GL_RGBA, %GL_UNSIGNED_BYTE, BYVAL STRPTR(strTextureData)

   ' Build lists
   box = glGenLists(2)                ' generate 2 different lists
   glNewList box, %GL_COMPILE         ' Start with the box list
      glBegin %GL_QUADS
         ' Bottom Face
         glNormal3f   0.0!,-1.0!, 0.0!
         glTexCoord2f 1.0!, 1.0! : glVertex3f -1.0!, -1.0!, -1.0!
         glTexCoord2f 0.0!, 1.0! : glVertex3f  1.0!, -1.0!, -1.0!
         glTexCoord2f 0.0!, 0.0! : glVertex3f  1.0!, -1.0!,  1.0!
         glTexCoord2f 1.0!, 0.0! : glVertex3f -1.0!, -1.0!,  1.0!
         ' Front Face
         glNormal3f   0.0!, 0.0!, 1.0!
         glTexCoord2f 0.0!, 0.0! : glVertex3f -1.0!, -1.0!,  1.0!
         glTexCoord2f 1.0!, 0.0! : glVertex3f  1.0!, -1.0!,  1.0!
         glTexCoord2f 1.0!, 1.0! : glVertex3f  1.0!,  1.0!,  1.0!
         glTexCoord2f 0.0!, 1.0! : glVertex3f -1.0!,  1.0!,  1.0!
         ' Back Face
         glNormal3f   0.0!, 0.0!, -1.0!
         glTexCoord2f 1.0!, 0.0! : glVertex3f -1.0!, -1.0!, -1.0!
         glTexCoord2f 1.0!, 1.0! : glVertex3f -1.0!,  1.0!, -1.0!
         glTexCoord2f 0.0!, 1.0! : glVertex3f  1.0!,  1.0!, -1.0!
         glTexCoord2f 0.0!, 0.0! : glVertex3f  1.0!, -1.0!, -1.0!
         ' Right face
         glNormal3f   1.0!, 0.0!, 0.0!
         glTexCoord2f 1.0!, 0.0! : glVertex3f  1.0!, -1.0!, -1.0!
         glTexCoord2f 1.0!, 1.0! : glVertex3f  1.0!,  1.0!, -1.0!
         glTexCoord2f 0.0!, 1.0! : glVertex3f  1.0!,  1.0!,  1.0!
         glTexCoord2f 0.0!, 0.0! : glVertex3f  1.0!, -1.0!,  1.0!
         ' Left Face
         glNormal3f  -1.0!, 0.0!, 0.0!
         glTexCoord2f 0.0!, 0.0! : glVertex3f -1.0!, -1.0!, -1.0!
         glTexCoord2f 1.0!, 0.0! : glVertex3f -1.0!, -1.0!,  1.0!
         glTexCoord2f 1.0!, 1.0! : glVertex3f -1.0!,  1.0!,  1.0!
         glTexCoord2f 0.0!, 1.0! : glVertex3f -1.0!,  1.0!, -1.0!
      glEnd
   glEndList
   top = box + 1                      ' Storage for "Top" is "Box" plus one
   glNewList top, %GL_COMPILE         ' Now the "Top" display list
      glBegin %GL_QUADS
         ' Top Face
         glNormal3f   0.0!, 1.0!, 0.0!
         glTexCoord2f 0.0!, 1.0! : glVertex3f -1.0!,  1.0!, -1.0!
         glTexCoord2f 0.0!, 0.0! : glVertex3f -1.0!,  1.0!,  1.0!
         glTexCoord2f 1.0!, 0.0! : glVertex3f  1.0!,  1.0!,  1.0!
         glTexCoord2f 1.0!, 1.0! : glVertex3f  1.0!,  1.0!, -1.0!
      glEnd
   glEndList

   REDIM boxcol(2, 4) AS SINGLE
   REDIM topcol(2, 4) AS SINGLE

   boxcol(0, 0) = 1.0! : boxcol(1, 0) = 0.0! : boxcol(2, 0)  = 0.0!
   boxcol(0, 1) = 1.0! : boxcol(1, 1) = 0.5! : boxcol(2, 1)  = 0.0!
   boxcol(0, 2) = 1.0! : boxcol(1, 2) = 1.0! : boxcol(2, 2)  = 0.0!
   boxcol(0, 3) = 0.0! : boxcol(1, 3) = 1.0! : boxcol(2, 3)  = 0.0!
   boxcol(0, 4) = 0.0! : boxcol(1, 4) = 1.0! : boxcol(2, 4)  = 1.0!

   topcol(0, 0) = 0.5! : topcol(1, 0) = 0.0! : topcol(2, 0)  = 0.0!
   topcol(0, 1) = 0.5! : topcol(1, 1) = 0.25!: topcol(2, 1)  = 0.0!
   topcol(0, 2) = 0.5! : topcol(1, 2) = 0.5! : topcol(2, 2)  = 0.0!
   topcol(0, 3) = 0.0! : topcol(1, 3) = 0.5! : topcol(2, 3)  = 0.0!
   topcol(0, 4) = 0.0! : topcol(1, 4) = 0.5! : topcol(2, 4)  = 0.5!

   ' Activate our newly created texture
   glEnable %GL_TEXTURE_2D
   ' Select smooth shading
   glShadeModel %GL_SMOOTH
   ' Specify clear values for the color buffers
   glClearColor 0.0!, 0.0!, 0.0!, 0.0!
   ' Specify the clear value for the depth buffer
   glClearDepth 1.0!
   ' Enable depth comparisons and update the depth buffer
   glEnable %GL_DEPTH_TEST
   ' Specify the value used for depth-buffer comparisons
   glDepthFunc %GL_EQUAL
   '  Quick and dirty lighting (assumes Light0 is set up)
   glEnable %GL_LIGHT0
	'  Enable lighting
'   glEnable %GL_LIGHTING
	' Enable material coloring
   glEnable %GL_COLOR_MATERIAL
	' Really nice perspective calculations
   glHint %GL_PERSPECTIVE_CORRECTION_HINT, %GL_NICEST

   ' Enable sticky keys
   glfwEnable %GLFW_STICKY_KEYS

   ' Disable vertical sync (on cards that support it)
   glfwSwapInterval 0

   ' Main loop
   running = %TRUE
   frames = 0
   t0 = glfwGetTime

   DO WHILE running

      ' Get time and mouse position
      t = glfwGetTime
      glfwGetMousePos x, y
      ' Calculate and display FPS (frames per second)
      IF t - t0 > 1.0! OR frames = 0 THEN
         fps = frames / (t-t0)
         wsprintf szTitlestr, "NEHE Lesson 12 (%i FPS)", BYVAL fps
         glfwSetWindowTitle szTitlestr
         t0 = t
         frames = 0
      END IF
      frames = frames + 1

      '  Get window size (may be different than the requested size)
      glfwGetWindowSize nWidth, nHeight
      IF nHeight <= 0 THEN nHeight = 1

      ' Set viewport
      glViewport 0, 0, nWidth, nHeight

      ' Clear the screen and depth buffers
      glClear %GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT

      ' Select and setup the projection matrix
      glMatrixMode %GL_PROJECTION
      glLoadIdentity

      ' Calculate the aspect ratio of the window
      gluPerspective 45.0!, nWidth/nHeight, 0.1!, 100.0!

      ' Select the modelview matrix
      glMatrixMode %GL_MODELVIEW
      glLoadIdentity

      glBindTexture %GL_TEXTURE_2D, glHandle
      FOR yloop = 1 TO 5
         FOR xloop = 0 TO yloop - 1
            glLoadIdentity             ' Reset the view
            glTranslatef 1.4! + (xloop * 2.8!) - (yloop * 1.4!),((6.0! - yloop) * 2.4!) - 7.0!, -20.0!
            glRotatef 45.0! - (2.0! * yloop) + xrot, 1.0!, 0.0!, 0.0!
            glRotatef 45.0! + yrot, 0.0!, 1.0!, 0.0!
            glColor3fv boxcol(0, yloop - 1)
            glCallList box
            glColor3fv topcol(0, yloop - 1)
            glCallList top
         NEXT
      NEXT

      ' Swap buffers
      glfwSwapBuffers

      IF glfwGetKey(%GLFW_KEY_LEFT) = %GLFW_PRESS THEN yrot = yrot - 0.2!
      IF glfwGetKey(%GLFW_KEY_RIGHT) = %GLFW_PRESS THEN yrot = yrot + 0.2!
      IF glfwGetKey(%GLFW_KEY_UP) = %GLFW_PRESS THEN xrot = xrot - 0.2!
      IF glfwGetKey(%GLFW_KEY_DOWN) = %GLFW_PRESS THEN xrot = xrot + 0.2!

      ' Check if the ESC key was pressed or the window was closed
      running = NOT glfwGetKey(%GLFW_KEY_ESC) AND glfwGetWindowParam(%GLFW_OPENED)

   LOOP

   ' Delete the texture
   IF glHandle THEN glDeleteTextures(1, glHandle)

   ' Delete the lists
   glDeleteLists box, 2

   ' Close OpenGL window and terminate GLFW
   glfwTerminate

END FUNCTION
' =======================================================================================
